#pragma once
#include "Vector.h"
#include "UTIL_Misc.h"
#define MAX_EFFECTS 1000

#define FX_EXPLOSION_SMALL 0
#define FX_PARTICLE_SPREAD 1
#define FX_PARTICLE_POWER 2
class Effect
{
public:
	Vec3 mPos;
	int mType;
	bool mRemove;
	int miTimer;

	Effect::Effect(Vec3 pos, int type)
	{
		mPos = pos;
		mType = type;
		mRemove = false;
		miTimer = 0;
	}
	virtual void Update();
	virtual void Draw();
};

void InsertGameFX(Vec3 P, int type);

class Explosion : public Effect
{
public:
	Explosion::Explosion(Vec3 pos, int type) : Effect(pos,type)
	{
		miTimer = 8;
	}
	void Explosion::Update()
	{
		miTimer--;
		if(miTimer<0)
			mRemove = true;
	}
	void Draw();
};
struct Particle
{
	Vec3 P,  V;
	int Life, maxLife;
};
class ParticleSpread : public Effect
{
public:

	Particle mParts[10];
	ParticleSpread::ParticleSpread(Vec3 pos, int type) : Effect(pos,type)
	{
		miTimer = 16;
		for(int n=0; n<10; n++)
		{
			mParts[n].P = pos;
			mParts[n].V = Vec3(UTIL_Misc::RandFloat(1)-0.5f,UTIL_Misc::RandFloat(1)-0.5f,0) * UTIL_Misc::RandFloat(5);
			mParts[n].Life = mParts[n].maxLife = (UTIL_Misc::Rand()%16)+1;
		}
	}
	void ParticleSpread::Update()
	{
		for(int n=0; n<10; n++)
		{
			mParts[n].P += mParts[n].V;
			mParts[n].V *= 0.975f;
			mParts[n].Life--;
		}
		miTimer--;
		if(miTimer<0)
			mRemove = true;
	}
	void Draw();
};

class ParticlePower : public Effect
{
public:

	Particle mParts[10];
	ParticlePower::ParticlePower(Vec3 pos, int type) : Effect(pos,type)
	{
		miTimer = 150;
		for(int n=0; n<10; n++)
		{
			mParts[n].P = pos + Vec3((UTIL_Misc::Rand()%30)-15,(UTIL_Misc::Rand()%30)-15,0);
			mParts[n].V = Vec3(UTIL_Misc::RandFloat(1)-0.5f,UTIL_Misc::RandFloat(1)-0.5f,0) * UTIL_Misc::RandFloat(15);
			mParts[n].Life = mParts[n].maxLife = (UTIL_Misc::Rand()%150)+1;
		}
	}
	void Update();
	void Draw();
};