#include "Entity.h"
#include "Engine.h"

void Entity::Update()
{
	if(mType == ENT_PLAYER)
	{
		mEntShapes.front().Color.y = sin((float)gpEng->miInternalClock*0.5f);
		mEntShapes.front().Color.x = 0;
		mEntShapes.front().Color.z = 1;
		if(gpEng->miTakeDamageTime%3==0 && gpEng->miTakeDamageTime>0)
			mEntShapes.front().Color = Vec3(1,1,1);
		//else
		//mEntShapes.front().Color = Vec3(UTIL_Misc::RandFloat(1.0f),UTIL_Misc::RandFloat(1.0f),UTIL_Misc::RandFloat(1.0f));
	}

	if(mType == ENT_MEDBOX)
	{
		mEntShapes.front().Color.y = sin((float)gpEng->miInternalClock*0.5f);
	}
	if(mType == ENT_TRIGGER)
	{
		pBody->setMotionState(((Trigger*)this)->pTarget->pBody->getMotionState());
		pBody->activate();
	}
	if(mType == ENT_STATIC || mType == ENT_CORE)
	{
		if(mEntShapes.front().Color.z == 0)
			mEntShapes.front().Color.y = sin((float)gpEng->miInternalClock*0.1f);
	}
	if(miDmgTime>0)
		miDmgTime--;
}
void Entity::TakeDamage(int amount)
{
	if(miLife<=0)
		return;

	if(mType == ENT_CORE && gpEng->miInternalClock < 15500)
		return;

	miLife -= amount;
	if(mType == ENT_BOX || mType == ENT_MEDBOX || mType == ENT_TRIGGER || mType == ENT_CORE)
		if(miLife<=0)
		{
			if(mType == ENT_CORE)
			{
				if(!gpEng->mbCoreDestroyed)
				{
					if(!gpEng->mGameEnts.empty())
					{
						std::list<Entity*>::iterator E;
						for(E=gpEng->mGameEnts.begin(); E!=gpEng->mGameEnts.end(); E++)
						{
							if((*E)->mType == ENT_BOXGEN)
							{
								((BoxGenerator*)(*E))->mbInfiniteBoxes = false;
								((BoxGenerator*)(*E))->miMaxBoxes = 0;
							}
							else if((*E)->mType == ENT_BOX)
							{
								(*E)->mbTagged = true;
							}
						}
					}					

					BoxGenerator* mGen3 = new BoxGenerator(EntityShape(Vec3(1,1,1),Vec3(1,1,1)),ENT_BOXGEN);
					mGen3->mForce = Vec3(60,30,0);
					mGen3->mPos = Vec3(-gpEng->mScroll.x-300,180,-70);
					mGen3->miRadius = 100;
					mGen3->miBoxFrequency = 3;
					mGen3->mbInfiniteBoxes = true;
					gpEng->mGameEnts.push_back(mGen3);
					mGen3 = new BoxGenerator(EntityShape(Vec3(1,1,1),Vec3(1,1,1)),ENT_BOXGEN);
					mGen3->mForce = Vec3(60,30,0);
					mGen3->mPos = Vec3(-gpEng->mScroll.x-300,90,-70);
					mGen3->miRadius = 100;
					mGen3->miBoxFrequency = 3;
					mGen3->mbInfiniteBoxes = true;
					gpEng->mGameEnts.push_back(mGen3);

					BoxGenerator* mGen2 = new BoxGenerator(EntityShape(Vec3(1,1,1),Vec3(1,1,1)),ENT_BOXGEN);
					mGen2->mForce = Vec3(0,100,0);
					mGen2->mPos = Vec3(-gpEng->mScroll.x-200,-100,-70);
					mGen2->miRadius = 100;
					mGen2->miBoxFrequency = 3;
					mGen2->mbInfiniteBoxes = true;
					gpEng->mGameEnts.push_back(mGen2);
				}

				gpEng->mbCoreDestroyed = true;
				gpEng->miScreenFlashTime = 75;
				gpEng->miHomeRun = 0;
				gpEng->miScore += 50000;
			}
			mRemove = true;
			if(mType == ENT_MEDBOX)
			{
				gpEng->GiveUpgrade();
				gpEng->miScore += 100;
			}
			if(mType == ENT_TRIGGER)
			{
				gpEng->miScore += 250;
				((Trigger*)this)->pTarget->mRemove = true;
			}
			else
				gpEng->miScore += miScoreValue;
		}
	if(mType != ENT_STATIC && mType != ENT_LASER && miDmgTime <=0)
	miDmgTime = 3;
	if(mType == ENT_TRIGGER)
	{
		if(((Trigger*)this)->pTarget->miDmgTime<=0)
			((Trigger*)this)->pTarget->miDmgTime = 3;
	}

}
void BoxGenerator::Update()
{
	if(mbScroll)
		mPos += gpEng->mScrollVel*0.02f;
	miFrequency++;
	int freq = miBoxFrequency;
	if(gpEng->miInternalClock<1000)
		freq *= 2;
	if(miFrequency>=freq / ((gpEng->miSegments+1) *0.65f))
	{
		miFrequency = 0;
		if(!mbInfiniteBoxes)
			miBoxCount++;
		if(miBoxCount>=miMaxBoxes)
			mRemove = true;

		btVector3 boxinertia;

		float C = UTIL_Misc::RandFloat(0.5f);
		Entity* Ent;
		btRigidBody* RB;
		if(bBigBoxes)
		{
			gpEng->mBoxShapeBig->calculateLocalInertia(15.5f,boxinertia);
			Vec3 boxinert(boxinertia.x(),boxinertia.y(),boxinertia.z());
				Ent = new Entity( EntityShape(Vec3(10,0,0),Vec3(10,10,10), Vec3(0.3f+C,0.3f+C,0.3f+C)), ENT_BOX);
				Ent->mEntShapes.push_back(EntityShape(Vec3(-10,0,0),Vec3(10,10,10), Vec3(0.3f+C*0.5f,0.3f+C*0.5f,0.3f+C*0.5f)));
				Ent->miLife = 350;
				Ent->miScoreValue = 500;
				RB = gpEng->InsertNewRigidBody(gpEng->mBoxShapeBig,Vec3(0,0,UTIL_Misc::Rand()%360),
				mPos + Vec3((UTIL_Misc::Rand()%miRadius)-(miRadius/2),(UTIL_Misc::Rand()%miRadius)-(miRadius/2),0),
			15.0f, boxinert, Ent, COL_ENTITY, COL_ENTITY | COL_LASER | COL_PLR | COL_STATIC);
			RB->setAngularFactor(btVector3(0,0,1));
		}
		else
		{
			int rndBox = UTIL_Misc::Rand()%250;
			gpEng->mBoxShape->calculateLocalInertia(5.5f,boxinertia);
			Vec3 boxinert(boxinertia.x(),boxinertia.y(),boxinertia.z());
			if(rndBox == 0 && gpEng->miInternalClock>500)
			{
				Ent = new Entity( EntityShape(Vec3(8,8,8), Vec3(1,0,0)), ENT_MEDBOX);
				Ent->mEntShapes.push_back(EntityShape(Vec3(-6,-6,-6), Vec3(4,4,4), Vec3(0.2f,0.2f,0.2f)));
				Ent->mEntShapes.push_back(EntityShape(Vec3(6,-6,-6), Vec3(4,4,4), Vec3(0.2f,0.2f,0.2f)));
				Ent->mEntShapes.push_back(EntityShape(Vec3(-6,-6,6), Vec3(4,4,4), Vec3(0.2f,0.2f,0.2f)));
				Ent->mEntShapes.push_back(EntityShape(Vec3(6,-6,6), Vec3(4,4,4), Vec3(0.2f,0.2f,0.2f)));
				Ent->mEntShapes.push_back(EntityShape(Vec3(-6,6,-6), Vec3(4,4,4), Vec3(0.2f,0.2f,0.2f)));
				Ent->mEntShapes.push_back(EntityShape(Vec3(6,6,-6), Vec3(4,4,4), Vec3(0.2f,0.2f,0.2f)));
				Ent->mEntShapes.push_back(EntityShape(Vec3(-6,6,6), Vec3(4,4,4), Vec3(0.2f,0.2f,0.2f)));
				Ent->mEntShapes.push_back(EntityShape(Vec3(6,6,6), Vec3(4,4,4), Vec3(0.2f,0.2f,0.2f)));
				Ent->miLife = 60;
				RB = gpEng->InsertNewRigidBody(gpEng->mBoxShapeMed,Vec3(UTIL_Misc::Rand()%360,UTIL_Misc::Rand()%360,UTIL_Misc::Rand()%360),
				mPos + Vec3((UTIL_Misc::Rand()%miRadius)-(miRadius/2),(UTIL_Misc::Rand()%miRadius)-(miRadius/2),0),
			10.0f, boxinert, Ent, COL_ENTITY, COL_ENTITY | COL_LASER | COL_PLR | COL_STATIC);
			}
			else
			{
				Ent = new Entity( EntityShape(Vec3(5,5,5), Vec3(0.3f+C,0.3f+C,0.3f+C)), ENT_BOX);
				RB = gpEng->InsertNewRigidBody(gpEng->mBoxShape,Vec3(UTIL_Misc::Rand()%360,UTIL_Misc::Rand()%360,UTIL_Misc::Rand()%360),
				mPos + Vec3((UTIL_Misc::Rand()%miRadius)-(miRadius/2),(UTIL_Misc::Rand()%miRadius)-(miRadius/2),0),
			1.0f, boxinert, Ent, COL_ENTITY, COL_ENTITY | COL_LASER | COL_PLR | COL_STATIC);
			}
		}
		RB->applyCentralImpulse(btVector3(mForce.x,mForce.y,mForce.z));
		gpEng->mGameEnts.push_back(Ent);

	}
}

void CompoundGenerator::Update()
{
	if(mbScroll)
		mPos += gpEng->mScrollVel*0.02f;
	miFrequency++;
	if(miFrequency>=miBoxFrequency)
	{
		miFrequency = 0;
		if(!mbInfiniteBoxes)
			miBoxCount++;
		if(miBoxCount>=miMaxBoxes)
			mRemove = true;


		float C = UTIL_Misc::RandFloat(0.5f);
		Entity* Ent = new Entity(EntityShape(mComShapes.front().Pos,mComShapes.front().Scale, mComShapes.front().Color), ENT_STATIC);
		std::list<EntityShape>::iterator IT;
		IT=mComShapes.begin();
		IT++;
		while(IT!=mComShapes.end())
		{
			Ent->mEntShapes.push_back(EntityShape((*IT).Pos,(*IT).Scale,(*IT).Color));
			IT++;
		}
		btRigidBody* RB;
		RB = gpEng->InsertNewRigidBody(pCompound,Vec3(0,0,0),
		mPos,
		mMass, inertia, Ent, COL_STATIC, COL_ENTITY | COL_LASER | COL_PLR);
		RB->applyCentralImpulse(btVector3(mForce.x,mForce.y,mForce.z));
		RB->setLinearFactor(btVector3(0,1,0));
		RB->setAngularFactor(btVector3(0,0,0));
		RB->setGravity(btVector3(0,0,0));
		RB->setLinearVelocity(btVector3(mForce.x,mForce.y,mForce.z));
		Ent->pBody = RB;
		gpEng->mGameEnts.push_back(Ent);

		Trigger* NewEnt = new Trigger( EntityShape(Vec3(10,10,10), Vec3(1,0,1)), ENT_TRIGGER);
		NewEnt->pTarget = gpEng->mGameEnts.back();
		RB = gpEng->InsertNewRigidBody(gpEng->mTriggerShape1,Vec3(0,0,0),
		mPos,
		mMass, inertia, NewEnt, COL_STATIC, COL_ENTITY | COL_LASER | COL_PLR | COL_STATIC);
		RB->applyCentralImpulse(btVector3(mForce.x,mForce.y,mForce.z));
		RB->setLinearFactor(btVector3(0,1,0));
		RB->setAngularFactor(btVector3(0,0,0));
		RB->setGravity(btVector3(0,0,0));
		RB->setLinearVelocity(btVector3(mForce.x,mForce.y,mForce.z));
		NewEnt->pBody = RB;
		Ent->pOwner = NewEnt;
		gpEng->mGameEnts.push_back(NewEnt);

	}
}