#pragma once
#include "UTIL_SDL.h"
#include <sdl_mixer.h>

bool InitializeAudio(int numChannels);
void ShutDownAudio();
void PauseAudio();
void UnPauseAudio();
void FadeOutAudio(int ticks);
void MasterVolume(int vol);

struct Music
{
	Mix_Music* pMusic;
	float fPlayedTime;
};

struct Sample
{
	Mix_Chunk* pSample;
};

bool LoadMusic(char* name, Music& music);
void FreeMusic(Music& music);
void PlayMusic(Music music, bool loop, bool pos);
void PlayMusicFadeIn(Music music, bool loop, int fadeticks, bool pos);
void MasterMusicFadeout(int ticks);
void MasterPauseMusic();
void MasterUnPauseMusic();
void MaserMusicVolume(int vol);
void StopMusic();
bool MusicIsPlaying();

bool LoadSample(char* name, Sample& sample);
void FreeSample(Sample& sample);

void SetChannelVolume(int chan, int vol);//vol 0-128
void SetMasterChannelVolume(int vol);
void PauseMasterChannel();
void UnPauseMasterChannel();
void PlaySample(int chan, Sample sample, bool loop);//specify channel
int PlaySample(Sample sample, bool loop);//next available channel
void StopChannel(int channel);
void StopMasterChannel();
void FadeInMasterChannel(int ticks);
void FadeOutMasterChannel(int ticks);
void SetSoundPosition(int channel, int angle, int distance);
void ReserveChannels(int num);